/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net) //打开网站
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); //2.0版本
 * you may not use this file except in compliance with the License. //使用该文件
 * You may obtain a copy of the License at //提交通行证
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. //BackupUtils 是一个备份工具类，用于数据备份读取和显示
 */

package net.micode.notes.tool; //定义了功能类数据

import android.content.Context; //. 导入小米便签需要的各项函数
import android.database.Cursor; //查询数据类型
import android.os.Environment; //导入环境包
import android.text.TextUtils; //导入安卓文本功能包
import android.text.format.DateFormat; //用于转换格式
import android.util.Log; //用于打印与查看日志的类

import net.micode.notes.R; // 从Notes项目的其他软件包中调用类。
import net.micode.notes.data.Notes; //数据便签类
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants; // 数据类型类
import net.micode.notes.data.Notes.NoteColumns; //便签类

import java.io.File; //引入java的文件处理，输入输出等功能
import java.io.FileNotFoundException; //文件未找到的错误处理
import java.io.FileOutputStream; //文件的输入
import java.io.IOException; //操作错误处理
import java.io.PrintStream; //导入所需要用到的包


public class BackupUtils { //备份工具类，从备份文件中恢复便签
    private static final String TAG = "BackupUtils"; //实例化化对象BackupUtils
    // Singleton stuff
    private static BackupUtils sInstance; //实例化一个BackupUnils的对象sInstance

    public static synchronized BackupUtils getInstance(Context context) { //定义一个synchronize的函数，每次运行到synchronize时，首先判断这个函数是否有别人在用这个方法，如果有就等完再用，否则即可调用此函数
        if (sInstance == null) { //如果当前备份不存在，则声明一个
            sInstance = new BackupUtils(context);
        }
        return sInstance; //返回当前sInstance的值（或备份文件）
    }

    /**
     * Following states are signs to represents backup or restore //以下状态用于表示备份或者恢复

     * status //定义状态常量
     */
    // Currently, the sdcard is not mounted
    public static final int STATE_SD_CARD_UNMOUONTED           = 0; //备份文件夹不存在
    // The backup file not exist
    public static final int STATE_BACKUP_FILE_NOT_EXIST        = 1; //数据已被破坏，可能被修改
    // The data is not well formated, may be changed by other programs
    public static final int STATE_DATA_DESTROIED               = 2; //系统出现错误
    // Some run-time exception which causes restore or backup fails
    public static final int STATE_SYSTEM_ERROR                 = 3; //导出成功
    // Backup or restore success
    public static final int STATE_SUCCESS                      = 4; //成功导出/状态正常
 
    private TextExport mTextExport; //实例化一个textexport的对象

    private BackupUtils(Context context) { //初始化函数
        mTextExport = new TextExport(context);
    }

    private static boolean externalStorageAvailable() { //判断外部存储功能是否可用
        return Environment.MEDIA_MOUNTED.equals(Environment.getExternalStorageState());
    }

    public int exportToText() { //输出至文本
        return mTextExport.exportToText(); // 返回输出文本状态
    }

    public String getExportedTextFileName() { //获取输出的文本文件名
        return mTextExport.mFileName; //返回输出文本的文件名
    }

    public String getExportedTextFileDir() { //获得输出文本的文本路径
        return mTextExport.mFileDirectory; //返回输出文本文件的路径
    }

    private static class TextExport { //定义了一个TextExport的类，包含笔记ID、修改日期、数据及其格式类型
        private static final String[] NOTE_PROJECTION = { //定义了一个数组储存便签的信息
                NoteColumns.ID,
                NoteColumns.MODIFIED_DATE,
                NoteColumns.SNIPPET,
                NoteColumns.TYPE
        };

        private static final int NOTE_COLUMN_ID = 0; //初始化标识：笔记ID标识为0；笔记的修改日期标识为1；笔记的数据标识为2.

        private static final int NOTE_COLUMN_MODIFIED_DATE = 1;

        private static final int NOTE_COLUMN_SNIPPET = 2;

        private static final String[] DATA_PROJECTION = { //定义字符串存储数据的基本信息
                DataColumns.CONTENT,
                DataColumns.MIME_TYPE,
                DataColumns.DATA1,
                DataColumns.DATA2,
                DataColumns.DATA3,
                DataColumns.DATA4,
        };

        private static final int DATA_COLUMN_CONTENT = 0; //标识设定：数据内容标识为0；媒体类型标识为1；访问日期标识为2；电话号码标识为4

        private static final int DATA_COLUMN_MIME_TYPE = 1;

        private static final int DATA_COLUMN_CALL_DATE = 2;

        private static final int DATA_COLUMN_PHONE_NUMBER = 4;

        private final String [] TEXT_FORMAT; //文档格式标识：名称赋值为0，日期赋值为1，内容赋值为2
        private static final int FORMAT_FOLDER_NAME          = 0;
        private static final int FORMAT_NOTE_DATE            = 1;
        private static final int FORMAT_NOTE_CONTENT         = 2;

        private Context mContext; //定义一个内部上下类
        private String mFileName; //定义文件名
        private String mFileDirectory; //定义文件夹路径
 
        public TextExport(Context context) { //从context类实例中获取信息，给对应的属性赋初始值
            TEXT_FORMAT = context.getResources().getStringArray(R.array.format_for_exported_note);
            mContext = context; //定义文件内容为便签内容
            mFileName = ""; //文件名初始化为空
            mFileDirectory = ""; //文件路径初始化为空
        }

        private String getFormat(int id) { //获取id对应的格式
            return TEXT_FORMAT[id];
        }

        /**
         * Export the folder identified by folder id to text //输出文件夹
         */
        private void exportFolderToText(String folderId, PrintStream ps) { //通过查询parent id是文件夹id的note来选出制定ID文件夹下的Note
            // Query notes belong to this folder
            Cursor notesCursor = mContext.getContentResolver().query(Notes.CONTENT_NOTE_URI, //根据便签目录的URI找到利用的数据，并根据PARENT_ID和文件ID在数据里查找，并放到游标中
                    NOTE_PROJECTION, NoteColumns.PARENT_ID + "=?", new String[] {
                        folderId
                    }, null); //如果查询结果非空那么按照时间格式输出最后修改的时间

            if (notesCursor != null) { //将查找到的数据全部导到文本里面
                if (notesCursor.moveToFirst()) { // 如果游标执行到第一行
                    do { //ps里面保存有这份note的日期
                        // Print note's last modified date
                        ps.println(String.format(getFormat(FORMAT_NOTE_DATE), DateFormat.format( //打印最后修改日期
                                mContext.getString(R.string.format_datetime_mdhm),
                                notesCursor.getLong(NOTE_COLUMN_MODIFIED_DATE))));
                        // Query data belong to this note
                        String noteId = notesCursor.getString(NOTE_COLUMN_ID); //查询属于该便签的数据
                        exportNoteToText(noteId, ps); //通过文件的标识将目录导出成文件
                    } while (notesCursor.moveToNext()); //遍历这个文件夹底下所有的便签
                }
                notesCursor.close(); //关闭游标
            }
        }

        /**
         * Export note identified by id to a print stream
         */
        private void exportNoteToText(String noteId, PrintStream ps) { //打印便签的内容，分为电话号码类型和便签类型
            Cursor dataCursor = mContext.getContentResolver().query(Notes.CONTENT_DATA_URI,
                    DATA_PROJECTION, DataColumns.NOTE_ID + "=?", new String[] { //将CONTENT_DATA_URI里DATA_PROFECTION内容扫描到游标中，按默认顺序进行排序
                        noteId
                    }, null);

            if (dataCursor != null) { //如果数据游标不为空
                if (dataCursor.moveToFirst()) {
                    do {
                        String mimeType = dataCursor.getString(DATA_COLUMN_MIME_TYPE); // 获得便签的媒体类型
                        if (DataConstants.CALL_NOTE.equals(mimeType)) { //判断便签的内容，如果是电话记录，那么在这一个代码块内打印
                            // Print phone number
                            String phoneNumber = dataCursor.getString(DATA_COLUMN_PHONE_NUMBER); //获取手机号码
                            long callDate = dataCursor.getLong(DATA_COLUMN_CALL_DATE); // 获取通话时长
                            String location = dataCursor.getString(DATA_COLUMN_CONTENT); //获取地址

                            if (!TextUtils.isEmpty(phoneNumber)) { //判断是否是空字符
                                ps.println(String.format(getFormat(FORMAT_NOTE_CONTENT), //输出电话号码phoneNumber
                                        phoneNumber));
                            }
                            // Print call date
                            ps.println(String.format(getFormat(FORMAT_NOTE_CONTENT), DateFormat //输出calldate
                                    .format(mContext.getString(R.string.format_datetime_mdhm),
                                            callDate)));
                            // Print call attachment location
                            if (!TextUtils.isEmpty(location)) { //判断是否存在位置信息
                                ps.println(String.format(getFormat(FORMAT_NOTE_CONTENT), //打印便签格式和位置信息
                                        location));
                            }
                        } else if (DataConstants.NOTE.equals(mimeType)) { //如果是便签的内容，那么直接输出便签里面包含的东西
                            String content = dataCursor.getString(DATA_COLUMN_CONTENT);
                            if (!TextUtils.isEmpty(content)) { //如果便签内容不为空值
                                ps.println(String.format(getFormat(FORMAT_NOTE_CONTENT), //判断文本包中内容是否为空，若非空则将文本内容输出到打印输出流中
                                        content));
                            }
                        }
                    } while (dataCursor.moveToNext()); //光标下移
                }
                dataCursor.close(); //关闭光标
            }
            // print a line separator between note
            try {
                ps.write(new byte[] { //在note下面输出一条线
                        Character.LINE_SEPARATOR, Character.LETTER_NUMBER
                });
            } catch (IOException e) { //检测异常，如果有异常输出红色TAG
                Log.e(TAG, e.toString()); //捕获错误信息并记录异常日志
            }
        }

        /**
         * Note will be exported as text which is user readable
         */
        public int exportToText() { //总函数，调用上面的exportFolder和exportNote
            if (!externalStorageAvailable()) { //检查外部设备安装情况，如果未安装好，则蓝色字体输出debug信息，并返回STATE_SD_CARD_UNMOUNOTED值为0
                Log.d(TAG, "Media was not mounted");
                return STATE_SD_CARD_UNMOUONTED;
            }

            PrintStream ps = getExportToTextPrintStream(); // 获得外部设备存储路径
            if (ps == null) { //导出文件夹，并导出里面包含的便签
                Log.e(TAG, "get print stream error"); //如果ps赋值失败，则输出显示错误的信息，并返回状态错误信息
                return STATE_SYSTEM_ERROR;
            } //导出文件夹及其中的便签
            // First export folder and its notes
            Cursor folderCursor = mContext.getContentResolver().query( //定位需要导出的文件夹
                    Notes.CONTENT_NOTE_URI,
                    NOTE_PROJECTION,
                    "(" + NoteColumns.TYPE + "=" + Notes.TYPE_FOLDER + " AND "
                            + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER + ") OR "
                            + NoteColumns.ID + "=" + Notes.ID_CALL_RECORD_FOLDER, null, null);

            if (folderCursor != null) { //文件夹游标不为空，即存在文件夹
                if (folderCursor.moveToFirst()) { //文件夹光标在第一行时
                    do { //打印输出文件夹的名称
                        // Print folder's name
                        String folderName = ""; //输出文件夹的名字 
                        if(folderCursor.getLong(NOTE_COLUMN_ID) == Notes.ID_CALL_RECORD_FOLDER) { // 根据folder在数据库中的位置来找到文件名
                            folderName = mContext.getString(R.string.call_record_folder_name);
                        } else {
                            folderName = folderCursor.getString(NOTE_COLUMN_SNIPPET); //若未得到文件夹位置，则从便签前面一部分字符串为文件夹名称
                        }
                        if (!TextUtils.isEmpty(folderName)) { //判断folderName是否存在，存在即输出其格式和flodername
                            ps.println(String.format(getFormat(FORMAT_FOLDER_NAME), folderName));
                        }
                        String folderId = folderCursor.getString(NOTE_COLUMN_ID); //通过便签id得到folderID
                        exportFolderToText(folderId, ps); //将文件夹中内容导出打印
                    } while (folderCursor.moveToNext()); //文件夹的光标下移
                }
                folderCursor.close(); //关闭游标
            }

            // Export notes in root's folder
            Cursor noteCursor = mContext.getContentResolver().query( //输出根目录下的便签
                    Notes.CONTENT_NOTE_URI,
                    NOTE_PROJECTION,
                    NoteColumns.TYPE + "=" + +Notes.TYPE_NOTE + " AND " + NoteColumns.PARENT_ID
                            + "=0", null, null);

            if (noteCursor != null) { //便签对应游标不为空
                if (noteCursor.moveToFirst()) { //便签光标下移
                    do {
                        ps.println(String.format(getFormat(FORMAT_NOTE_DATE), DateFormat.format( //打印便签的修改时间
                                mContext.getString(R.string.format_datetime_mdhm),
                                noteCursor.getLong(NOTE_COLUMN_MODIFIED_DATE)))); //访问便签中的数据的相关信息
                        // Query data belong to this note
                        String noteId = noteCursor.getString(NOTE_COLUMN_ID); //找到这块数据的ID.
                        exportNoteToText(noteId, ps); //将便签以文本的形式导出并打印
                    } while (noteCursor.moveToNext()); // 便签光标下移
                }
                noteCursor.close(); //关闭游标
            }
            ps.close();

            return STATE_SUCCESS; //返回成功导出的状态
        }

        /**
         * Get a print stream pointed to the file {@generateExportedTextFile}
         */
        private PrintStream getExportToTextPrintStream() { //将要输出的内容整合到一个输出里并返回该输出流
            File file = generateFileMountedOnSDcard(mContext, R.string.file_path, //初始化存储在SD卡的文件
                    R.string.file_name_txt_format);
            if (file == null) { //如果文件为空，则创建失败
                Log.e(TAG, "create file to exported failed"); //记录异常日志
                return null;
            }
            mFileName = file.getName(); //获取文件名字
            mFileDirectory = mContext.getString(R.string.file_path); //获取文件路径
            PrintStream ps = null; //初始化ps
            try {
                FileOutputStream fos = new FileOutputStream(file); //将ps输出流输出到特定的文件，目的就是导出到文件，而不是直接输出
                ps = new PrintStream(fos);
            } catch (FileNotFoundException e) { //找不到系统指定文件
                e.printStackTrace();
                return null;
            } catch (NullPointerException e) { //捕获空指针异常
                e.printStackTrace();
                return null;
            }
            return ps;
        }
    }

    /**
     * Generate the text file to store imported data
     */
    private static File generateFileMountedOnSDcard(Context context, int filePathResId, int fileNameFormatResId) { //生成文件存储在外部存储器上
        StringBuilder sb = new StringBuilder(); //构建一个动态字符串将外部存储器路径、文件路径、编辑时间加入到其中
        sb.append(Environment.getExternalStorageDirectory()); //加入外部SD卡的存储路径
        sb.append(context.getString(filePathResId)); //文件的存储路径
        File filedir = new File(sb.toString()); //存储路径信息
        sb.append(context.getString( //格式化输出当前系统时间
                fileNameFormatResId,
                DateFormat.format(context.getString(R.string.format_date_ymd), //将当前的系统时间以预定的格式输出
                        System.currentTimeMillis()))); 
        File file = new File(sb.toString()); // 创建包含输出内容的文件

        try { //若没有安全异常、输入输出异常，则在没有文件夹或文件的情况下新建
            if (!filedir.exists()) {
                filedir.mkdir();
            }
            if (!file.exists()) {
                file.createNewFile();
            }
            return file; //返回导出的文件
        } catch (SecurityException e) { //捕获安全异常的状况
            e.printStackTrace();
        } catch (IOException e) { //输入输出异常处理
            e.printStackTrace();
        }

        return null; //try catch 异常处理
    }
}


